<?php
/*-------------------------------------------------------+
| SEO Friendly 1.2
| Author: Wojciech Mycka (zer0) wmycka@nlds-group.com
| http://nlds-group.com
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

include INFUSIONS."seo_friendly/infusion_db.php";

$result = dbquery("SELECT * FROM ".DB_SF." WHERE seo_id='1'");
$data = dbarray($result);	

echo "\n<!-- SEO Friendly Infusion v.1.2 - Powered by: NLDS-Group.com -->\n";

if ($data['seo_removeframe'] == "1") {
	echo "<meta http-equiv='window-target' content='_top' />\n";
}
echo "<meta name='subject' content='".$data['seo_subject']."' />\n";
echo "<meta name='category' content='".$data['seo_category']."' />\n";
echo "<meta name='rating' content='".$data['seo_rating']."' />\n";
echo "<meta name='author' content='".$data['seo_author']."' />\n";
echo "<meta name='distribution' content='".$data['seo_distribution']."' />\n";
echo "<meta name='copyright' content='".$settings['sitename']."' />\n";
echo "<meta name='revisit' content='".$data['seo_revisit']."' />\n";
echo "<meta name='designer' content='".$data['seo_designer']."' />\n";
echo "<meta name='robots' content='".$data['seo_robots']."' />\n";
echo "<meta name='googlebot' content='".$data['seo_googlebot1']."' />\n";
if ($data['seo_googlebot2'] == "1") {
	echo "<meta name='googlebot' content='noarchive' />\n";
}
if ($data['seo_googlebot3'] == "1") {
	echo "<meta name='googlebot' content='nosnippet' />\n";
}
if ($data['seo_emulateie7'] == "1") {
	echo "<meta http-equiv='X-UA-Compatible' content='IE=EmulateIE7' />\n";
}
echo "<!-- END - SEO Friendly Infusion v.1.2 -->\n\n";

if ($data['seo_friendly_url'] == "1") {
	function friendly_url($seo_url) {
			// HOME
			$seo_url = preg_replace('#news\.php#si', 'home.html', $seo_url);
			$seo_url = preg_replace('#news\.php\?readmore=([0-9]*?)(\'|")#si', 'news-view-\1.html\2', $seo_url);
			$seo_url = preg_replace('#news_cats\.php#si', 'news-cat.html', $seo_url);

			// ARTICLES
			$seo_url = preg_replace('#articles\.php#si', 'articles.html', $seo_url);
			$seo_url = preg_replace('#articles\.php\?cat_id=([0-9]*?)(\'|")#si', 'articles-cat-\1.html\2', $seo_url);
			$seo_url = preg_replace('#readarticle.php?article_id=([0-9]*?)(\'|")#si', 'read-article-1.html\2', $seo_url);

			// DOWNLOADS
			$seo_url = preg_replace('#downloads\.php#si', 'downloads.html', $seo_url);
			$seo_url = preg_replace('#downloads\.php\?cat_id=([0-9]*?)(\'|")#si', 'downloads-cat-\1.html\2', $seo_url);
			$seo_url = preg_replace('#downloads\.php\?cat_id=([0-9]*?)(&|&)download_id=([0-9]*?)(\'|")#si', 'downloads-\1-save-\3.html\4', $seo_url);

			// FAQ
			$seo_url = preg_replace('#faq\.php#si', 'faq.html', $seo_url);
			$seo_url = preg_replace('#faq\.php\?cat_id=([0-9]*?)(\'|")#si', 'faq-cat-\1.html\2', $seo_url);

			// WEBLINKS
			$seo_url = preg_replace('#weblinks\.php#si', 'weblinks.html', $seo_url);
			$seo_url = preg_replace('#weblinks\.php\?cat_id=([0-9]*?)(\'|")#si', 'weblinks-cat-\1.html\2', $seo_url);
			$seo_url = preg_replace('#weblinks\.php\?cat_id=([0-9]*?)(&|&)weblink_id=([0-9]*?)(\'|")#si', 'weblinks-\1-view-\3.html\4', $seo_url);

			// SEARCH
			$seo_url = preg_replace('#search\.php#si', 'search.html', $seo_url);
			$seo_url = preg_replace('#search\.php\?stype=f#si', 'search-forum.html', $seo_url);

			// PHOTOGALLERY
			$seo_url = preg_replace('#photogallery\.php#si', 'gallery.html', $seo_url);
			$seo_url = preg_replace('#photogallery\.php\?album_id=([0-9]*?)(\'|")#si', 'gallery-album-\1.html\2', $seo_url);
			$seo_url = preg_replace('#photogallery\.php\?photo_id=([0-9]*?)(\'|")#si', 'gallery-foto-\1.html\2', $seo_url);
			$seo_url = preg_replace('#showphoto\.php\?photo_id=([0-9]*?)(\'|")#si', 'gallery-foto-view-\1.html\2', $seo_url); 

			// MESSAGES
			$seo_url = preg_replace('#messages\.php#si', 'messages.html', $seo_url);

			// MISC
			$seo_url = preg_replace('#members\.php#si', 'members.html', $seo_url);
			$seo_url = preg_replace('#contact\.php#si', 'contact.html', $seo_url);
			$seo_url = preg_replace('#register\.php#si', 'register.html', $seo_url);
			$seo_url = preg_replace('#lostpassword\.php#si', 'lostpassword.html', $seo_url);
			$seo_url = preg_replace('#edit_profile\.php#si', 'edit-profile.html', $seo_url);
			$seo_url = preg_replace('#print\.php\?type=N(&|&)item_id=([0-9]*?)(\'|")#si', 'print-news-\2.html\3', $seo_url);
			$seo_url = preg_replace('#print\.php\?type=A(&|&)item_id=([0-9]*?)(\'|")#si', 'print-article-\2.html\3', $seo_url);
			$seo_url = preg_replace('#profile\.php\?group_id=([0-9]*?)(\'|")#si', 'group-profile-\1.html\2', $seo_url);

			// IF EXISTS NICK MOD INFUSION (OH)
			if(file_exists(INFUSIONS."nicks_mod_panel/nicks_mod_cache.php")){
				include INFUSIONS.'nicks_mod_panel/nicks_mod_cache.php';
				if(!empty($nicks_mod_cache)) {
					preg_match_all('#<a.*?href=\''.BASEDIR.'profile\.php\?lookup=([0-9]+)\'.*?>#', $seo_url, $matches);
					$matches = array_unique($matches[1]);
					if(!empty($matches)) {
						$users_ids = '';
						foreach($matches as $user_id) { $users_ids .= ($users_ids ? ',' : '').$user_id; }
						unset($matches);
						$result = dbquery('SELECT user_id, user_groups, user_level, user_primarygroup FROM '.DB_USERS.' WHERE (user_groups !="" OR user_level IN (102,103)) AND user_id IN ('.$users_ids.')');
						while($data = dbarray($result)) {
							$user_groups = (strpos($data['user_groups'], ".") == 0 ? explode(".", substr($data['user_groups'], 1)) : explode(".", $data['user_groups']));
							if($data['user_level']=='102' || $data['user_level']=='103') { $user_groups[] = "l".$data['user_level']; }
							if(isset($data['user_primarygroup']) && count($user_groups) > 1 && array_key_exists($data['user_primarygroup'], $nicks_mod_cache)) {
								$seo_url = preg_replace('#<a([^<>]*)href=\''.BASEDIR.'profile\.php\?lookup='.$data['user_id'].'\'([^<>]*)>([-0-9A-Z_@\s]*)</a>#si', '<a\\1href=\''.BASEDIR.'profile-'.$data['user_id'].'.html\'\\2><span style=\'color:'.$nicks_mod_cache[$data['user_primarygroup']][0].';'.$nicks_mod_cache[$data['user_primarygroup']][2].'\'>'.$nicks_mod_cache[$data['user_primarygroup']][1].'\\3</span></a>', $seo_url);
							} else {
								foreach($user_groups as $user_group) {
									if(array_key_exists($user_group, $nicks_mod_cache)) { 
										$seo_url = preg_replace('#<a([^<>]*)href=\''.BASEDIR.'profile\.php\?lookup='.$data['user_id'].'\'([^<>]*)>([-0-9A-Z_@\s]*)</a>#si', '<a\\1href=\''.BASEDIR.'profile-'.$data['user_id'].'.html\'\\2><span style=\'color:'.$nicks_mod_cache[$user_group][0].';'.$nicks_mod_cache[$user_group][2].'\'>'.$nicks_mod_cache[$user_group][1].'\\3</span></a>', $seo_url);
										break; 
									}
								}
							}
						}
					}
				}
				return $seo_url;
			} else {
				$seo_url = preg_replace('#profile\.php\?lookup=([0-9]*?)(\'|")#si', 'profile-\1.html\2', $seo_url);
			}

			// FORUM
			$seo_url = preg_replace('#forum/index.php#si', 'forum/index.html', $seo_url);
			$seo_url = preg_replace('#viewforum\.php\?forum_id=([0-9]*?)(\'|")#si', 'forum-view-\1.html\2', $seo_url); 
			$seo_url = preg_replace('#viewthread\.php\?forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(\'|")#si', 'forum-view-\1-thread-\3.html\4', $seo_url);
			$seo_url = preg_replace('#viewthread\.php\?rowstart=([0-9]*?)(&|&)forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(\'|")#si', 'forum-page-\1-forum-\3-thread-\5.html\6', $seo_url);
			$seo_url = preg_replace('#viewthread\.php\?forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(&|&)pid=([0-9]*?)\#post_([0-9]*?)(\'|")#si', 'forum-view-\1-thread-\3-post-\5.html#post_\6\7', $seo_url);
			$seo_url = preg_replace('#post\.php\?action=newthread(&|&)forum_id=([0-9]*?)(\'|")#si', 'new-thread-\2.html\3', $seo_url);
			$seo_url = preg_replace('#viewthread\.php\?thread_id=([0-9]*?)(\'|")#si', 'thread-view-\1.html\2', $seo_url);
			$seo_url = preg_replace('#viewthread\.php\?forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(&|&)rowstart=([0-9]*?)(\'|")#si', 'forum-view-\1-thread-\3-page-\5.html\6', $seo_url);
			$seo_url = preg_replace('#post\.php\?action=edit(&|&)forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(&|&)post_id=([0-9]*?)(\'|")#si', 'edit-\2-thread-\4-post-\6.html\7', $seo_url);
			$seo_url = preg_replace('#post\.php\?action=reply(&|&)forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(\'|")#si', 'reply-forum-\2-thread-\4.html\5', $seo_url);
			$seo_url = preg_replace('#post\.php\?action=reply(&|&)forum_id=([0-9]*?)(&|&)thread_id=([0-9]*?)(&|&)post_id=([0-9]*?)(&|&)quote=([0-9]*?)(\'|")#si', 'reply-forum-\2-thread-\4-post-\6-cyt-\8.html\9', $seo_url);
		return $seo_url;
	}
	add_handler("friendly_url");
}

if ($data['seo_optimaze_html'] == "1") {
	function optimaze_html($html) {
			$html = preg_replace('#<br>#si', '<br />', $html);
			$html = preg_replace('#<hr>#si', '<hr />', $html);
			$html = preg_replace('#<b>#si', '<strong>', $html);
			$html = preg_replace('#</b>#si', '</strong>', $html);
			$html = preg_replace('#<i>#si', '<em>', $html);
			$html = preg_replace('#</i>#si', '</em>', $html);
			$html = preg_replace('#<u>#si', '<span style="text-decoration:underline;">', $html);
			$html = preg_replace('#</u>#si', '</span>', $html);
			$html = preg_replace('#<s>#si', '<span style="text-decoration:line-through;">', $html);
			$html = preg_replace('#</s>#si', '</span>', $html);
			$html = preg_replace('#<center>#si', '<div style="text-align:center;">', $html);
			$html = preg_replace('#</center>#si', '</div>', $html);
			$html = preg_replace('#<small>([-0-9A-Z_@\s]*)</small>#si', '<span style="font-size:smaller;">\1</span>', $html);
		return $html;
	}
	add_handler("optimaze_html");
}

if ($data['seo_optimaze_meta'] == "1") {
	function optimaze_meta($meta) {
			$result = dbquery("SELECT description, keywords FROM ".DB_SETTINGS."");
			$ustawienia = dbarray($result);	
			$uciete_description = substr($ustawienia['description'],0,155);
			$uciete_keywords = substr($ustawienia['keywords'],0,400);
			$meta = preg_replace('#<meta name=\'description\' content=\'([-0-9A-Z_@\s]*)\' />#si', '<meta name=\'description\' content=\''.$uciete_description.'\' />', $meta);
			$meta = preg_replace('#<meta name=\'keywords\' content=\'([-0-9A-Z_@\s]*)\' />#si', '<meta name=\'keywords\' content=\''.$uciete_keywords.'\' />', $meta);
		return $meta;
	}
	add_handler("optimaze_meta");
}
?>


